<?php
/*
Plugin Name: NBC History IP Excluder
Version: 1.0.a
Description: Permet l'exclusion d'une IP ou d'une plage d'IP de l historique - Excludes one IP or a range of IP from the history. plugin directement derive de Stats Ip Excluder de Eric 
Plugin URI: http://phpwebgallery.net/ext/extension_view.php?eid=147
Author: Nicco
Author URI: http://gallery-nicco.no-ip.org
*/
if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

/* ******************* */
/* Class of the plugin */
/* ******************* */
class IpExclude
{
  var $my_config; /* Configuration file items */
  
  /* Loading of the configuration file - If not exist -> Configuration file creation */
  function load_config()
  {
    $x = @file_get_contents( dirname(__FILE__).'/data.dat' );
    if ($x!==false)
    {
      $c = unserialize($x);
      // do some more tests here
      $this->my_config = $c;
    }
    if ( !isset($this->my_config)
        or empty($this->my_config['ip_excluded']) )
    {
      $this->my_config['ip_excluded'] = array( '' ); /* list of IP to exclude */
      $this->my_config['ip_activated'] = false; /* Possibility to disactivate the exclusion */
      $this->save_config();
    }
  }

  /* Saving of the configuration file with data */
  function save_config()
  {
    $file = fopen( dirname(__FILE__).'/data.dat', 'w' );
    fwrite($file, serialize($this->my_config) );
    fclose( $file );
  }

/* Set the administration panel of the plugin */
  function plugin_admin_menu($menu)
  {
    array_push($menu,
        array(
          'NAME' => 'History IP Excluder',
          'URL' => get_admin_plugin_menu_link(dirname(__FILE__).'/admin/ip_exclude_admin.php')
        )
      );
    return $menu;
  }

/* Exclusion function */
  function IpExclusion($pwg_will_log)
  {
    if ((!$pwg_will_log) or (!$this->my_config['ip_activated']))
      return $pwg_will_log;
	
    $do_log = true;
  
    $IP_Client = explode(".", $_SERVER['REMOTE_ADDR']);
	
    foreach ( $this->my_config['ip_excluded'] as $Exclusion )
    {
      $IP_Exclude = explode(".", $Exclusion);

      if ( (($IP_Client[0] == $IP_Exclude[0]) or ($IP_Exclude[0] == '%') or ($IP_Exclude[0] == '')) and
           (($IP_Client[1] == $IP_Exclude[1]) or ($IP_Exclude[1] == '%') or ($IP_Exclude[1] == '')) and
           (($IP_Client[2] == $IP_Exclude[2]) or ($IP_Exclude[2] == '%') or ($IP_Exclude[2] == '')) and
           (($IP_Client[3] == $IP_Exclude[3]) or ($IP_Exclude[3] == '%') or ($IP_Exclude[3] == ''))
         )
      {
        $do_log = false;
      }    
    }
	   
    return $do_log;
  }
}

$obj = new IpExclude(); /* class loading */
$obj->load_config(); /* Configuration file loading */

add_event_handler( 'pwg_log_allowed', array(&$obj, 'IpExclusion') );
add_event_handler('get_admin_plugin_menu_links', array(&$obj, 'plugin_admin_menu') );
set_plugin_data($plugin['id'], $obj);
?>
